#!/usr/bin/env python
# coding: utf-8

# In[43]:


import numpy as np


# In[44]:


#eine "zufällige" Matrix
A=np.array([ 
    [1,2,1],
    [1,0,-1],
    [2,1,0]
])


# In[45]:


#Die QR-Zerlegung von A:
Q,R=np.linalg.qr(A)
print(Q)
print(R)


# In[46]:


# ist die tatsächlich die QR-Zerlegung?
Q.dot(R)


# In[47]:


#die ersten 20 Schritte vom QR-Verfahren

Ak=[A]
for i in range(20):
    Q,R=np.linalg.qr(Ak[-1]) # nimm das letzte Ak=Ak[-1] und davon die QR-Zerlegung
    Ak.append(R.dot(Q)) # speichere A_(k+1):=RQ


# In[48]:


# unsere Annäherung nach 20 Schritten ~ obere Dreiecksmatrix
Ak[-1]


# In[49]:


#Die tatsächlichen Eigenwerte von A sind:
lambda1=2, # ~ D[0][0]
lambda2=-(np.sqrt(5)+1)/2 #~ -1.6180339887498948482 ~ D[1][1]
lambda3=( np.sqrt(5)-1)/2 #~  0.6180339887498948482 ~ D[2][2]


# In[50]:


#wenn wir die Einträge unterhalb der Diagonalen zwischen den Schritten vergleichen erhalten wir:
print(Ak[-2][1][0]/Ak[-1][1][0]) #=A^k_{1,2} / A^{k-1}_{1,2} ~ lambda1/lambda2
print(lambda1/lambda2)
print(Ak[-2][2][0]/Ak[-1][2][0]) # ~ lambda1/lambda3
print(lambda1/lambda3)
print(Ak[-2][2][1]/Ak[-1][2][1]) # ~ lambda2/lambda3
print(lambda2/lambda3)


# In[51]:


#das gleiche für eine "zufällige" symmetrische Matrix
B=A.T.dot(A)
print(B)

Bk=[B]
V=np.identity(3)
for i in range(20):
    Q,R=np.linalg.qr(Bk[-1])
    Bk.append(R.dot(Q))
    V=V.dot(Q) # speichere noch das Produkt der Orthogonalmatrizen


# In[52]:


Bk[-1]


# In[53]:


#Ist V orthogonal?
V.T.dot(V) # ~ Identität


# In[54]:


#Besteht V aus Eigenvektoren?
V.T.dot(B).dot(V) # ~ Diagonalmatrix


# In[ ]:




